;********************************************************************************************************
;                                              uC/OS-II
;                                        The Real-Time Kernel
;
;                    Copyright 1992-2021 Silicon Laboratories Inc. www.silabs.com
;
;                                 SPDX-License-Identifier: APACHE-2.0
;
;               This software is subject to an open source license and is distributed by
;                Silicon Laboratories Inc. pursuant to the terms of the Apache License,
;                    Version 2.0 available at www.apache.org/licenses/LICENSE-2.0.
;
;********************************************************************************************************

;********************************************************************************************************
;
;                                       MCS51-STC8 Specific code
;                                           keil C51 Compiler
;
; Filename : os_cpu_i.h
; Version  : V2.93.01
;********************************************************************************************************

#include "os_cfg.h"
#include "STC8H.h"

;********************************************************************************************************
;                                           I/O PORT ADDRESSES
;********************************************************************************************************



;********************************************************************************************************
;                                                MACROS
;********************************************************************************************************
;定义压栈宏
PUSHALL    MACRO
        USING 0     ;工作寄存器0  AR0~AR7 对应00~07H地址
        PUSH PSW
;        MOV PSW,#00H    ;这里屏蔽这条主要原因是规定整个工程用寄存器组0，而且中断是统一管理的， 去掉加速。
        PUSH ACC
        PUSH B
        PUSH DPL
        PUSH DPH
        PUSH AR0
        PUSH AR1
        PUSH AR2
        PUSH AR3
        PUSH AR4
        PUSH AR5
        PUSH AR6
        PUSH AR7
        
IF USE_DUAL_DPTR <> 0
        PUSH DPS
        PUSH DPL1
        PUSH DPH1
ENDIF
IF ACCESS_FULL_64K_XDATA <> 0
        PUSH P_SW2
ENDIF
        ENDM
        
;定义出栈宏
POPALL    MACRO
        USING 0     ;工作寄存器0  AR0~AR7 对应00~07H地址
IF ACCESS_FULL_64K_XDATA <> 0
        POP  ACC
        ANL  A,#0x80
        ANL  P_SW2,#0x7F 
        ORL  P_SW2,A
ENDIF
IF USE_DUAL_DPTR <> 0
        POP  DPH1
        POP  DPL1
        POP  DPS
ENDIF        
        POP  AR7
        POP  AR6
        POP  AR5
        POP  AR4
        POP  AR3
        POP  AR2
        POP  AR1
        POP  AR0
        POP  DPH
        POP  DPL
        POP  B
        POP  ACC
        POP  PSW
        ENDM
